--*** needs to be modified to work with generic plugin (currently still based on moormap)

importPath=string.gsub(getfenv(1)._.Name,"%.OptionsWindow","").."."
if ColorPicker==nil then
	import (importPath.."ColorPicker")
end
-- need to create the options window
OptionsWindow = Turbine.UI.Lotro.Window()

OptionsWindow:SetText(Resource[language][3]);
OptionsWindow:SetVisible(false);
OptionsWindow:SetSize(540,550);
OptionsWindow:SetPosition((Turbine.UI.Display:GetWidth() - OptionsWindow:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - OptionsWindow:GetHeight()) / 2);

OptionsWindow.HadErrors=false;
OptionsWindow.OptionsPanel=Turbine.UI.Control();
OptionsWindow.OptionsPanel:SetParent(OptionsWindow);
OptionsWindow.OptionsPanel:SetSize(OptionsWindow:GetWidth()-30,OptionsWindow:GetHeight()-80);
OptionsWindow.OptionsPanel:SetPosition(15,40);
OptionsWindow.OptionsPanel:SetBackColor(Settings.BackColor);

OptionsWindow.OptionsCaption=Turbine.UI.Label();
OptionsWindow.OptionsCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
OptionsWindow.OptionsCaption:SetForeColor(Settings.HeadingsColor);
OptionsWindow.OptionsCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth(),20);
OptionsWindow.OptionsCaption:SetPosition(0,0);
OptionsWindow.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
OptionsWindow.OptionsCaption:SetText(Resource[language][4]..":");

OptionsWindow.LanguageCaption=Turbine.UI.Label();
OptionsWindow.LanguageCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.LanguageCaption:SetPosition(10,OptionsWindow.OptionsCaption:GetTop()+OptionsWindow.OptionsCaption:GetHeight()+9);
OptionsWindow.LanguageCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.LanguageCaption:SetForeColor(Settings.FontColor);
OptionsWindow.LanguageCaption:SetText(Resource[language][5]..":");

OptionsWindow.LanguageList=DropDownList();
OptionsWindow.LanguageList:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.LanguageList:SetPosition(OptionsWindow.LanguageCaption:GetLeft()+OptionsWindow.LanguageCaption:GetWidth()+2,OptionsWindow.LanguageCaption.GetTop()-3);
OptionsWindow.LanguageList:SetSize(OptionsWindow.OptionsPanel:GetWidth()-(OptionsWindow.LanguageCaption:GetWidth()+OptionsWindow.LanguageCaption:GetLeft())-65,20);
OptionsWindow.LanguageList:SetBorderColor(Settings.TrimColor);
OptionsWindow.LanguageList:SetBackColor(Settings.BackColor);
OptionsWindow.LanguageList:SetCurrentBackColor(Settings.BackColor);
OptionsWindow.LanguageList:SetDropRows(5);

local tmpLanguage;
-- add item for "Use Client Language"
do
	local tmpLanguage=1
	if locale=="fr" then
		tmpLanguage=2
	elseif locale=="de" then
		tmpLanguage=3
	end
	OptionsWindow.LanguageList:AddItem(Resource[tmpLanguage][21],-1);
end
for tmpLanguage in pairs(Resource) do
	OptionsWindow.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
end

OptionsWindow.LanguageList.SelectedIndexChanged = function ()
	OptionsWindow:SetLanguage(OptionsWindow.LanguageList:GetValue())
end

-- trim color
OptionsWindow.TrimCaption=Turbine.UI.Label();
OptionsWindow.TrimCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.TrimCaption:SetPosition(10,OptionsWindow.LanguageCaption:GetTop()+OptionsWindow.LanguageCaption:GetHeight()+9);
OptionsWindow.TrimCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.TrimCaption:SetForeColor(Settings.FontColor);
OptionsWindow.TrimCaption:SetText(Resource[language][6]..":");
OptionsWindow.TrimColor=ColorPicker();
OptionsWindow.TrimColor:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.TrimColor:SetPosition(OptionsWindow.TrimCaption:GetLeft()+OptionsWindow.TrimCaption:GetWidth()+5,OptionsWindow.TrimCaption:GetTop()-1);
OptionsWindow.TrimColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.TrimColor:SetColor(Settings.TrimColor);
OptionsWindow.TrimColor.ColorChanged=function()
	OptionsWindow:SetTrimColor(OptionsWindow.TrimColor:GetColor());
end

OptionsWindow.BackCaption=Turbine.UI.Label();
OptionsWindow.BackCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.BackCaption:SetPosition(10,OptionsWindow.TrimColor:GetTop()+OptionsWindow.TrimColor:GetHeight()+9);
OptionsWindow.BackCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.BackCaption:SetForeColor(Settings.FontColor);
OptionsWindow.BackCaption:SetText(Resource[language][7]..":");
OptionsWindow.BackColor=ColorPicker();
OptionsWindow.BackColor:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.BackColor:SetPosition(OptionsWindow.BackCaption:GetLeft()+OptionsWindow.BackCaption:GetWidth()+5,OptionsWindow.BackCaption:GetTop()-1);
OptionsWindow.BackColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.BackColor:SetColor(Settings.BackColor);
OptionsWindow.BackColor.ColorChanged=function()
	OptionsWindow:SetBackColor(OptionsWindow.BackColor:GetColor());
end

OptionsWindow.FontCaption=Turbine.UI.Label();
OptionsWindow.FontCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.FontCaption:SetPosition(10,OptionsWindow.BackColor:GetTop()+OptionsWindow.BackColor:GetHeight()+9);
OptionsWindow.FontCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.FontCaption:SetForeColor(Settings.FontColor);
OptionsWindow.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
OptionsWindow.FontColor=ColorPicker();
OptionsWindow.FontColor:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.FontColor:SetPosition(OptionsWindow.FontCaption:GetLeft()+OptionsWindow.FontCaption:GetWidth()+5,OptionsWindow.FontCaption:GetTop()-1);
OptionsWindow.FontColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.FontColor:SetColor(Settings.FontColor);
OptionsWindow.FontColor.ColorChanged=function()
	OptionsWindow:SetFontColor(OptionsWindow.FontColor:GetColor());
end

OptionsWindow.HeadingsCaption=Turbine.UI.Label();
OptionsWindow.HeadingsCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.HeadingsCaption:SetPosition(10,OptionsWindow.FontColor:GetTop()+OptionsWindow.FontColor:GetHeight()+9);
OptionsWindow.HeadingsCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.HeadingsCaption:SetForeColor(Settings.FontColor);
OptionsWindow.HeadingsCaption:SetText(Resource[language][15]..":");
OptionsWindow.HeadingsColor=ColorPicker();
OptionsWindow.HeadingsColor:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.HeadingsColor:SetPosition(OptionsWindow.HeadingsCaption:GetLeft()+OptionsWindow.HeadingsCaption:GetWidth()+5,OptionsWindow.HeadingsCaption:GetTop()-1);
OptionsWindow.HeadingsColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.HeadingsColor:SetColor(Settings.HeadingsColor);
OptionsWindow.HeadingsColor.ColorChanged=function()
	OptionsWindow:SetHeadingsColor(OptionsWindow.HeadingsColor:GetColor());
end

OptionsWindow.ListTextCaption=Turbine.UI.Label();
OptionsWindow.ListTextCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.ListTextCaption:SetPosition(10,OptionsWindow.HeadingsColor:GetTop()+OptionsWindow.HeadingsColor:GetHeight()+9);
OptionsWindow.ListTextCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.ListTextCaption:SetForeColor(Settings.FontColor);
OptionsWindow.ListTextCaption:SetText(Resource[language][16]..":");
OptionsWindow.ListTextColor=ColorPicker();
OptionsWindow.ListTextColor:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.ListTextColor:SetPosition(OptionsWindow.ListTextCaption:GetLeft()+OptionsWindow.ListTextCaption:GetWidth()+5,OptionsWindow.ListTextCaption:GetTop()-1);
OptionsWindow.ListTextColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.ListTextColor:SetColor(Settings.ListTextColor);
OptionsWindow.ListTextColor.ColorChanged=function()
	OptionsWindow:SetListTextColor(OptionsWindow.ListTextColor:GetColor());
end

OptionsWindow.ResetColors=Turbine.UI.Lotro.Button();
OptionsWindow.ResetColors:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.ResetColors:SetSize(160,20);
OptionsWindow.ResetColors:SetPosition((OptionsWindow.OptionsPanel:GetWidth()-OptionsWindow.ResetColors:GetWidth())/2,OptionsWindow.ListTextColor:GetTop()+OptionsWindow.ListTextColor:GetHeight()+9);
OptionsWindow.ResetColors:SetText(Resource[language][9]);
OptionsWindow.ResetColors.Click=function()
		Settings.TrimColor=Turbine.UI.Color(.2,.5,.9);
		Settings.FontColor=Turbine.UI.Color(1,.9,.5);
		Settings.BackColor=Turbine.UI.Color(.05,.05,.05);
		Settings.HeadingsColor=Turbine.UI.Color(1,1,1);
		Settings.ListTextColor=Turbine.UI.Color(1,1,1);
	OptionsWindow.TrimColor:SetColor(Settings.TrimColor);
	OptionsWindow.FontColor:SetColor(Settings.FontColor);
	OptionsWindow.BackColor:SetColor(Settings.BackColor);
	OptionsWindow.HeadingsColor:SetColor(Settings.HeadingsColor);
	OptionsWindow.ListTextColor:SetColor(Settings.ListTextColor);
end

OptionsWindow.OpacityCaption=Turbine.UI.Label();
OptionsWindow.OpacityCaption:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.OpacityCaption:SetPosition(10,OptionsWindow.ResetColors:GetTop()+OptionsWindow.ResetColors:GetHeight()+9);
OptionsWindow.OpacityCaption:SetSize(OptionsWindow.OptionsPanel:GetWidth()-301,18);
OptionsWindow.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.OpacityCaption:SetForeColor(Settings.FontColor);
OptionsWindow.OpacityCaption:SetText(Resource[language][13]..":");
OptionsWindow.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
OptionsWindow.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
OptionsWindow.OpacityScrollbar:SetParent(OptionsWindow.OptionsPanel)
OptionsWindow.OpacityScrollbar:SetPosition(OptionsWindow.OpacityCaption:GetLeft()+OptionsWindow.OpacityCaption:GetWidth()+5,OptionsWindow.OpacityCaption:GetTop());
OptionsWindow.OpacityScrollbar:SetSize(OptionsWindow.OptionsPanel:GetWidth()-OptionsWindow.OpacityCaption:GetWidth()-OptionsWindow.OpacityCaption:GetLeft()-15,10);
OptionsWindow.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
OptionsWindow.OpacityScrollbar:SetMinimum(0);
OptionsWindow.OpacityScrollbar:SetMaximum(100);
OptionsWindow.OpacityScrollbar.OriginalValue=100;
OptionsWindow.OpacityScrollbar.ValueChanged=function()
	mainWindow:SetOpacity(OptionsWindow.OpacityScrollbar:GetValue()/100);
end

-- **** There's a MAJOR BUG with checkboxes, they don't always change Checked value when you click IN the box, only on the label :(
-- so we implement the base checkbox class and provide our own image that we can forward mouse clicks on to here...
-- yeah, it's hokey, but it works as a place holder until Turbine fixes their Checkboxes


-- Load Minimized
OptionsWindow.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.LoadMinimizedCB:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.LoadMinimizedCB:SetForeColor(Settings.FontColor);
OptionsWindow.LoadMinimizedCB:SetSize(OptionsWindow.OptionsPanel:GetWidth()-15,18);
OptionsWindow.LoadMinimizedCB:SetPosition(10,OptionsWindow.OpacityCaption:GetTop()+OptionsWindow.OpacityCaption:GetHeight()+4);
OptionsWindow.LoadMinimizedCB:SetText(Resource[language][17]);

OptionsWindow.LMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
OptionsWindow.LMCBIcon:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.LMCBIcon:SetSize(OptionsWindow.LoadMinimizedCB:GetSize());
OptionsWindow.LMCBIcon:SetPosition(OptionsWindow.LoadMinimizedCB:GetPosition());
OptionsWindow.LMCBIcon.MouseClick=function()
	OptionsWindow.LoadMinimizedCB:SetChecked(not OptionsWindow.LoadMinimizedCB:IsChecked());
end
OptionsWindow.LMCBIcon:SetZOrder(OptionsWindow.LoadMinimizedCB:GetZOrder()+1);

-- Show Icon when Minimized
OptionsWindow.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.ShowIconWhenMinimizedCB:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.ShowIconWhenMinimizedCB:SetForeColor(Settings.FontColor);
OptionsWindow.ShowIconWhenMinimizedCB:SetSize(OptionsWindow.OptionsPanel:GetWidth()-15,18);
OptionsWindow.ShowIconWhenMinimizedCB:SetPosition(10,OptionsWindow.LoadMinimizedCB:GetTop()+OptionsWindow.LoadMinimizedCB:GetHeight()+4);
OptionsWindow.ShowIconWhenMinimizedCB:SetText(Resource[language][18]);

OptionsWindow.SIWMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
OptionsWindow.SIWMCBIcon:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.SIWMCBIcon:SetSize(OptionsWindow.ShowIconWhenMinimizedCB:GetSize());
OptionsWindow.SIWMCBIcon:SetPosition(OptionsWindow.ShowIconWhenMinimizedCB:GetPosition());
OptionsWindow.SIWMCBIcon.MouseClick=function()
	OptionsWindow.ShowIconWhenMinimizedCB:SetChecked(not OptionsWindow.ShowIconWhenMinimizedCB:IsChecked());
end
OptionsWindow.SIWMCBIcon:SetZOrder(OptionsWindow.ShowIconWhenMinimizedCB:GetZOrder()+1);

-- Use 16x16 Icon
OptionsWindow.UseMiniIconCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.UseMiniIconCB:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.UseMiniIconCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.UseMiniIconCB:SetForeColor(Settings.FontColor);
OptionsWindow.UseMiniIconCB:SetSize(OptionsWindow.OptionsPanel:GetWidth()-15,18);
OptionsWindow.UseMiniIconCB:SetPosition(10,OptionsWindow.ShowIconWhenMinimizedCB:GetTop()+OptionsWindow.ShowIconWhenMinimizedCB:GetHeight()+4);
OptionsWindow.UseMiniIconCB:SetText(Resource[language][201]);

OptionsWindow.UMICBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
OptionsWindow.UMICBIcon:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.UMICBIcon:SetSize(OptionsWindow.UseMiniIconCB:GetSize());
OptionsWindow.UMICBIcon:SetPosition(OptionsWindow.UseMiniIconCB:GetPosition());
OptionsWindow.UMICBIcon.MouseClick=function()
	OptionsWindow.UseMiniIconCB:SetChecked(not OptionsWindow.UseMiniIconCB:IsChecked());
end
OptionsWindow.UMICBIcon:SetZOrder(OptionsWindow.UseMiniIconCB:GetZOrder()+1);

-- Mini Icon is opaque
OptionsWindow.MiniIconOpaqueCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.MiniIconOpaqueCB:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.MiniIconOpaqueCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.MiniIconOpaqueCB:SetForeColor(Settings.FontColor);
OptionsWindow.MiniIconOpaqueCB:SetSize(OptionsWindow.OptionsPanel:GetWidth()-15,18);
OptionsWindow.MiniIconOpaqueCB:SetPosition(30,OptionsWindow.UseMiniIconCB:GetTop()+OptionsWindow.UseMiniIconCB:GetHeight()+4);
OptionsWindow.MiniIconOpaqueCB:SetText(Resource[language][202]);

OptionsWindow.UMICBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
OptionsWindow.UMICBIcon:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.UMICBIcon:SetSize(OptionsWindow.MiniIconOpaqueCB:GetSize());
OptionsWindow.UMICBIcon:SetPosition(OptionsWindow.MiniIconOpaqueCB:GetPosition());
OptionsWindow.UMICBIcon.MouseClick=function()
	OptionsWindow.MiniIconOpaqueCB:SetChecked(not OptionsWindow.MiniIconOpaqueCB:IsChecked());
end
OptionsWindow.UMICBIcon:SetZOrder(OptionsWindow.MiniIconOpaqueCB:GetZOrder()+1);

-- Other Options ?
OptionsWindow.DebugCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.DebugCB:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.DebugCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.DebugCB:SetForeColor(Settings.FontColor);
OptionsWindow.DebugCB:SetSize(OptionsWindow.OptionsPanel:GetWidth()-15,18);
OptionsWindow.DebugCB:SetPosition(10,OptionsWindow.MiniIconOpaqueCB:GetTop()+OptionsWindow.MiniIconOpaqueCB:GetHeight()+4);
OptionsWindow.DebugCB:SetText("Debug");

OptionsWindow.DebugIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
OptionsWindow.DebugIcon:SetParent(OptionsWindow.OptionsPanel);
OptionsWindow.DebugIcon:SetSize(OptionsWindow.DebugCB:GetSize());
OptionsWindow.DebugIcon:SetPosition(OptionsWindow.DebugCB:GetPosition());
OptionsWindow.DebugIcon.MouseClick=function()
	OptionsWindow.DebugCB:SetChecked(not OptionsWindow.DebugCB:IsChecked());
end
OptionsWindow.DebugIcon:SetZOrder(OptionsWindow.DebugCB:GetZOrder()+1);

--** SAVE AND CANCEL
OptionsWindow.SaveButton=Turbine.UI.Lotro.Button();
OptionsWindow.SaveButton:SetParent(OptionsWindow);
OptionsWindow.SaveButton:SetSize(100,20);
OptionsWindow.SaveButton:SetPosition(20,OptionsWindow:GetHeight()-40);
OptionsWindow.SaveButton:SetText(Resource[language][11]);
OptionsWindow.SaveButton.Click=function()
	local hasError=false;
	-- validate option values

	if hasError then
		OptionsWindow.ErrorLabel:SetVisible(true);
		OptionsWindow.HadErrors=true;
		OptionsWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
		OptionsWindow:SetWantsUpdates(true);
	else
		debug=OptionsWindow.DebugCB:IsChecked();
		if debug then debugWindow:SetVisible(true) end
		rb=OptionsWindow.LoadMinimizedCB:IsChecked();
		rb=OptionsWindow.ShowIconWhenMinimizedCB:IsChecked();
		Settings.UseMiniIcon=OptionsWindow.UseMiniIconCB:IsChecked()
		Settings.MiniIconOpaque=OptionsWindow.MiniIconOpaqueCB:IsChecked()
		Settings.LoadMinimized=OptionsWindow.LoadMinimizedCB:IsChecked()
		Settings.ShowIconWhenMinimized=OptionsWindow.ShowIconWhenMinimizedCB:IsChecked()
		Settings.FontColor=OptionsWindow.FontColor:GetColor();
		Settings.TrimColor=OptionsWindow.TrimColor:GetColor();
		Settings.BackColor=OptionsWindow.BackColor:GetColor();
		Settings.HeadingsColor=OptionsWindow.HeadingsColor:GetColor();
		Settings.ListTextColor=OptionsWindow.ListTextColor:GetColor();
		Settings.Opacity=mainWindow:GetOpacity() -- opacity is previewed live

		Settings.Language=OptionsWindow.LanguageList:GetValue();
		-- handle "Use Client" option (-1)
		if Settings.Language==-1 then
			language=1;
			if locale=="de" then
				language=3;
			elseif locale=="fr" then
				language=2;
			end
		else
			language=Settings.Language
		end

		mainWindow:SetFontColor();
		mainWindow:SetTrimColor();
		mainWindow:SetBackColor();
		mainWindow:SetHeadingsColor();
		mainWindow:SetLanguage();
		mainWindow:SetListTextColor();
		OptionsWindow:SetVisible(false);
	end
end

OptionsWindow.CancelButton=Turbine.UI.Lotro.Button();
OptionsWindow.CancelButton:SetParent(OptionsWindow);
OptionsWindow.CancelButton:SetSize(100,20);
OptionsWindow.CancelButton:SetPosition(OptionsWindow:GetWidth()-20-OptionsWindow.CancelButton:GetWidth(),OptionsWindow:GetHeight()-40);
OptionsWindow.CancelButton:SetText(Resource[language][12]);
OptionsWindow.CancelButton.Click=function()
	mainWindow:SetOpacity(OptionsWindow.OpacityScrollbar.OriginalValue);
	OptionsWindow.FontColor:SetColor(Settings.FontColor);
	OptionsWindow.TrimColor:SetColor(Settings.TrimColor);
	OptionsWindow.BackColor:SetColor(Settings.BackColor);
	OptionsWindow.HeadingsColor:SetColor(Settings.HeadingsColor);
	OptionsWindow:SetVisible(false);
end

OptionsWindow.ErrorLabel=Turbine.UI.Label();
OptionsWindow.ErrorLabel:SetParent(OptionsWindow);
OptionsWindow.ErrorLabel:SetText("Adjusted Invalid Values")
OptionsWindow.ErrorLabel:SetPosition(OptionsWindow.SaveButton:GetLeft()+OptionsWindow.SaveButton:GetWidth(),OptionsWindow.SaveButton:GetTop());
OptionsWindow.ErrorLabel:SetSize(OptionsWindow.CancelButton:GetLeft()-(OptionsWindow.ErrorLabel:GetLeft()),OptionsWindow.SaveButton:GetHeight());
OptionsWindow.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
OptionsWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
OptionsWindow.ErrorLabel:SetVisible(false);
OptionsWindow.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

OptionsWindow.LanguageList:SetZOrder(OptionsWindow:GetZOrder()+1);

OptionsWindow.VisibleChanged=function(sender,args)
	if OptionsWindow:IsVisible() then
			-- refresh the options status to reflect current values
		OptionsWindow.OpacityScrollbar.OriginalValue=Settings.Opacity;
		OptionsWindow.OpacityScrollbar:SetValue(math.floor(OptionsWindow.OpacityScrollbar.OriginalValue*100));
		OptionsWindow.LoadMinimizedCB:SetChecked(Settings.LoadMinimized);
		OptionsWindow.ShowIconWhenMinimizedCB:SetChecked(Settings.ShowIconWhenMinimized);
		OptionsWindow.UseMiniIconCB:SetChecked(Settings.UseMiniIcon);
		OptionsWindow.MiniIconOpaqueCB:SetChecked(Settings.MiniIconOpaque);
		OptionsWindow.DebugCB:SetChecked(debug);

		local index;
		for index=1,OptionsWindow.LanguageList.ListData:GetItemCount() do
			if OptionsWindow.LanguageList.ListData:GetItem(index):GetValue()==Settings.Language then
				OptionsWindow.LanguageList:SetSelectedIndex(index);
				break;
			end
		end
		OptionsWindow:SetLanguage(Settings.Language);
	end
end
OptionsWindow.Update=function(sender,args)
	if OptionsWindow.HadErrors then
		if Turbine.Engine:GetGameTime()>OptionsWindow.ErrorFadeTime then
			OptionsWindow:SetWantsUpdates(false);
			OptionsWindow.ErrorLabel:SetVisible(false);
			OptionsWindow.HadErrors=false
		end
	end
end
OptionsWindow.SetTrimColor=function(sender,color)
	OptionsWindow.LanguageList:SetBorderColor(color);
	OptionsWindow.FontColor:SetTrimColor(color);
	OptionsWindow.TrimColor:SetTrimColor(color);
	OptionsWindow.BackColor:SetTrimColor(color);
	OptionsWindow.HeadingsColor:SetTrimColor(color);
	OptionsWindow.ListTextColor:SetTrimColor(color);
end
OptionsWindow.SetBackColor=function(sender,color)
	OptionsWindow.LanguageList:SetBackColor(color);
	OptionsWindow.LanguageList:SetCurrentBackColor(color);
	OptionsWindow.OptionsPanel:SetBackColor(color);
	OptionsWindow.FontColor:SetBackColor(color);
	OptionsWindow.TrimColor:SetBackColor(color);
	OptionsWindow.BackColor:SetBackColor(color);
	OptionsWindow.HeadingsColor:SetBackColor(color);
	OptionsWindow.ListTextColor:SetBackColor(color);
end
OptionsWindow.SetFontColor=function(sender,color)
	OptionsWindow.LanguageCaption:SetForeColor(color);
	OptionsWindow.LoadMinimizedCB:SetForeColor(color);
	OptionsWindow.ShowIconWhenMinimizedCB:SetForeColor(color);
	OptionsWindow.UseMiniIconCB:SetForeColor(color);
	OptionsWindow.MiniIconOpaqueCB:SetForeColor(color);
	OptionsWindow.TrimCaption:SetForeColor(color);
	OptionsWindow.FontCaption:SetForeColor(color);
	OptionsWindow.BackCaption:SetForeColor(color);
	OptionsWindow.HeadingsCaption:SetForeColor(color);
	OptionsWindow.ListTextCaption:SetForeColor(color);
	OptionsWindow.OpacityCaption:SetForeColor(color);
end
OptionsWindow.SetHeadingsColor=function(sender,color)
	OptionsWindow.OptionsCaption:SetForeColor(color);
end
OptionsWindow.SetListTextColor=function(sender,color)
	OptionsWindow.LanguageList:SetTextColor(color);
end

OptionsWindow.SetLanguage=function(sender,tmpLanguage)
	if tmpLanguage==-1 then
		tmpLanguage=1
		if locale=="fr" then
			tmpLanguage=2
		elseif locale=="de" then
			tmpLanguage=3
		end
	end
	OptionsWindow:SetText(Resource[tmpLanguage][3]);
	OptionsWindow.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
	OptionsWindow.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
	OptionsWindow.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
	OptionsWindow.BackCaption:SetText(Resource[tmpLanguage][7]..":");
	OptionsWindow.FontCaption:SetText(Resource[tmpLanguage][8]..":");
	OptionsWindow.HeadingsCaption:SetText(Resource[tmpLanguage][15]..":");
	OptionsWindow.ListTextCaption:SetText(Resource[tmpLanguage][16]..":");
	OptionsWindow.ResetColors:SetText(Resource[tmpLanguage][9]);
	OptionsWindow.OpacityCaption:SetText(Resource[tmpLanguage][13]..":");

	OptionsWindow.LoadMinimizedCB:SetText(Resource[tmpLanguage][17]);
	OptionsWindow.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][18]);
	OptionsWindow.UseMiniIconCB:SetText(Resource[tmpLanguage][19]);
	OptionsWindow.MiniIconOpaqueCB:SetText(Resource[tmpLanguage][20]);

	OptionsWindow.SaveButton:SetText(Resource[tmpLanguage][11]);
	OptionsWindow.CancelButton:SetText(Resource[tmpLanguage][12]);
end
