-- note, this file should probably be saved in UTF-8 due to having many accented strings
-- There is a distinct version of this file for the current game client running. Since the file only has to match the actual client language, the user choice is irrelevant (we only display the info in the language the client is running)
MaliceIDate=1713326401 -- known datetime for variant 1, 2024/04/17 03:00:00 (1713326400-10799) adjusted for 3AM offset(time zone UTC+5 which is why it is 18000 seconds higher)
--1713337200
-- subtract MaliceIDate from current datetime, divide by 86400 to get in days, divide to get raw date divide by 6 and remainder*6 + 1 is current variant
-- math.modf(math.floor((currDateTime-MaliceIDate)/86400)/6)+1
-- i.e. on 4/22/2024 at 9:15:00 AM we would have math.floor((1713791700-1713326401)/86400) which is 5, divide by 6 is 5/6, math.modf(5/6)*6 is 5/6*6=5, +1 is 6 so 4/22/2024 is variant 6
-- i.e. on 5/20/2024 at 7:49:26 PM we would have math.floor((1716205766-1713326401)/86400) which is  33, divide by 6 is 33/6, math.modf(33/6)*6 is 3/6*6=3, +1 is 3 so 5/20/2024 is variant 4

-- need to test GetLocalTime() to see if it returns server time or client local time

EpicMalices={} -- Name, Description
EpicMalices[1]={"Epic Fervour","Every enemy you defeat makes you stronger."}
EpicMalices[2]={"Epic Tempest",""}
EpicMalices[3]={"Epic Orc Tunnels","Orcs have been digging under your feet! Every 45 seconds an Orc tunnel will appear. Destroy the tunnel before Orcs emerge."}

EpicEffect={} -- Name, Description, Removal Method, Duration (or nil), {Effects}
EpicEffect[1]={"Clutch of Flies II","A distinct buzzing sound can be heard coming from an ill-attached sack on the monster's hip. A wrong move on its part and it could easily open up.","Cleanse Corruption"}
-- example of duration and effect sub-table
EpicEffect[2]={"For the Warleader","On defeat, enemies are inspired to fight harder. Increases nearby enemy mitigation and damage.","",30,{"-20% Incomming Melee Damage", "-20% Incomming Ranged Damage", "-20% Incomming Tactical Damage", "+20% Melee Damage", "+20% Ranged Damage", "+20% Tactical Damage"}}
EpicEffect[3]={"Glass Cannon","Having forsaken defense, these creatures have become far more deadly.","",nil,{"+100% Melee Damage", "+100% Ranged Damage", "+100% Tactical Damage", "+50% Incoming Melee Damage", "+50% Incoming Ranged Damage", "+50% Incoming Tactical Damage"}}
EpicEffect[4]={"Debilitating Miasma","The miasma surrounding this foe is debilitating, and fighting in it will make your attacks less effective.","",nil,{"+100% Melee Damage", "+100% Ranged Damage", "+100% Tactical Damage", "+50% Incoming Melee Damage", "+50% Incoming Ranged Damage", "+50% Incoming Tactical Damage"}}
EpicEffect[5]={"Sauron's Defence I","Attacking this creature returns a portion of the damage dealt gback to you.","Cleanse Corruption",nil,{"On any damage: Reflect 5% of Shadow damage"}}
EpicEffect[6]={"Sauron's Defence II","Attacking this creature returns a portion of the damage dealt gback to you.","Cleanse Corruption",nil,{"On any damage: Reflect 30% of Shadow damage"}}
EpicEffect[7]={"Sauron's Shroud","The will of Sauron shrouds this creature from sight and makes it more observan of enemies.","",nil,{"+1 Stealth Level", "+50% Perception Radius"}}
EpicEffect[8]={"Creeping Doom","You feel a creeping dread fill you with fear, if not cleansed you will be overcome with it.","Clear Fear",10,{"Applied on expiration: 6s Stun"}}
EpicEffect[9]={"Diseased Cloud I","A vile cloud of disease hangs in the air here.","",nil,{"Every 3 Seconds: Subtracts 9% of maximum Morale"}}
EpicEffect[10]={"Diseased Cloud II","A vile cloud of disease hangs in the air here.","",nil,{"Every 3 Seconds: Subtracts 15% of maximum Morale"}}
EpicEffect[11]={"Explosive Devastation I","The enemy explodes into a gout of flame!","Cure Wound",9,{"Every 3 seconds: Subtracts 7% of maximum Morale"}}
EpicEffect[12]={"Explosive Devastation II","The enemy explodes into a gout of flame!","Cure Wound",12,{"Every 3 seconds: Subtracts 12% of maximum Morale"}}
EpicEffect[13]={"Fire-storm I","The air catches fire and blows gouts of flame around you!","",nil,{"Every 3 seconds: Subtracts 8% of maximum Morale"}}
EpicEffect[14]={"Fire-storm II","The air catches fire and blows gouts of flame around you!","",nil,{"Every 3 seconds: Subtracts 20% of maximum Morale"}}
EpicEffect[15]={"Virulent Cloud","A miasma so potent it cannot be cured.","",nil,{"Drains 200 Power over 3.0 seconds"}}
EpicEffect[15]={"Blood Rage High I","Enemies give and take less damage at high health. At low health, enemies give and take more damage.","",nil,{"-25% Melee Damage, -25% Ranged Damage, -25% Tactical Damage, -25% Incoming Melee Damage, -25% Incoming Ranged Damage, -25% Incoming Tactical Damage"}}
--*** need to verify low effect
EpicEffect[16]={"Blood Rage Low I","Enemies give and take more damage at low health.","",nil,{"+25% Melee Damage, +25% Ranged Damage, +25% Tactical Damage, +25% Incoming Melee Damage, +25% Incoming Ranged Damage, +25% Incoming Tactical Damage"}}
EpicEffect[17]={"Blood Rage High II","Enemies give and take less damage at high health. At low health, enemies give and take more damage.","",nil,{"-50% Melee Damage, -50% Ranged Damage, -50% Tactical Damage, -50% Incoming Melee Damage, -50% Incoming Ranged Damage, -50% Incoming Tactical Damage"}}
--*** need to verify low effect
EpicEffect[18]={"Blood Rage Low II","Enemies give and take more damage at low health.","",nil,{"+50% Melee Damage, +50% Ranged Damage, +50% Tactical Damage, +50% Incoming Melee Damage, +50% Incoming Ranged Damage, +50% Incoming Tactical Damage"}}
EpicEffect[19]={"High on Life I","Enemies start out doing double damage. Once reduced below 85% health, this malice abandons them.","Morale below 85%",nil,{"+100% Melee Damage, +100% Ranged Damage, +100% Tactical Damage"}}
EpicEffect[20]={"High on Life II","Enemies start out doing double damage. Once reduced below 40% health, this malice abandons them.","Morale below 40%",nil,{"+100% Melee Damage, +100% Ranged Damage, +100% Tactical Damage"}}
EpicEffect[21]={"Sauron's Lash","Monsters are fast. Really fast.","",nil,{"+50% Run Speed, -50% Skill Inductions"}}
EpicEffect[22]={"Poison Puddles I","Poison puddles up from the ground here!","",nil,{"Every 3 Seconds: Subtracts 10% of maximum Morale"}}
EpicEffect[23]={"Poison Puddles II","Poison puddles up from the ground here!","",nil,{"Every 3 Seconds: Subtracts 20% of maximum Morale"}}
EpicEffect[24]={"Daunting Disease","A disease that saps your vigour.","Cure Disease",60,{"Reduces morale by 30%"}}
EpicEffect[25]={"Stab at Thee","You've been stabbed! Cleanse your wound.","Cure Wound",10,{"On expiration: Deep Wound, 14994 common damage every 2.0 seconds for 20 seconds"}}
EpicEffect[26]={"Health Poultices","This enemy will heal itself until it is seriously wounded.","Morale below 85%",nil,{"Heals 1661 Morale every 3.0 seconds"}}
EpicEffect[27]={"Thick Hide","This monster has a thicker hide and looks more difficult to damage. A Critical Hit will breach the hide.","Critical Hit",nil,{"Incomming Damage is reduced by 50%"}}
EpicEffect[28]={"Encroaching Shadow","This enemy has 20% Light and Beleriand weapon mitigation.","",nil,{"+33% Light Mitigation", "+40% Beleriand Mitigation"}}
EpicEffect[29]={"Lingering Fear","You are filled with fear. Healing is less effective. Cleanse yourself and find your resolve.","Clear Fear",20,{"-50% Incoming Healing Modifier", "-90% Outgoing Healing Modifier", "Applied on removal: Subtracts 15% of maximum Morale"}}
EpicEffect[30]={"Melee Mastery","Expert training has made this creature a dangerous foe to face in melee.","",nil,{"+150% Melee Damage"}}
EpicEffect[31]={"Sauron's Eye III","The Eye of Sauron falls upon this creature, creating a palpable aura of dread to surround it.","",nil,{"+3 Dread"}}
EpicEffect[32]={"Pestilent Discharge","You are slowed. This fungus is about to burst. Get away from it!","",8,{}}
EpicEffect[33]={"Slime Puddles I","Steady on! Slime puddles cause your aim to be unsteady.","",nil,{}}
EpicEffect[34]={"Instilled Panic","A terrible chill crawls up your spine. You have less chance to do critical damage and lowered defences against critical damage.","Clear Fear",15,{"-25% Critical Defence", "-60% Melee Critical Chance", "-60% Ranged Critical Chance", "-60% Tactical Critical Chance"}}
EpicEffect[35]={"Glory In Pain","This monster finds glory in the face of pain, healing itself the more it is attacked.","Cleanse Corruption",10,{}}
EpicEffect[36]={"Deadly at Range","Expert Training has turned this creature into a deadly marksman.","",nil,{"+150% Ranged Damage"}}
EpicEffect[37]={"Tactical Mastery","Expert training has made this creature a dangerous foe to face in tactical combat.","",nil,{"+120% Tactical Damage"}}
EpicEffect[38]={"Infested!","There's a shooting pain in your abdomen, and also a squirming sensation... almost as if there were... something moving.","Cure Disease",10,{"Applied on expiration if in combat: Stun 6s"}}
EpicEffect[39]={"Clutch of Flies I","A swarm of flies has latched onto you, making it harder to land a meaningful blow!","",nil,{"-15% Melee Critical Chance","-15% Ranged Critical Chance","-15% Tactical Critical Chance"}}
EpicEffect[40]={"Clutch of Flies II","A swarm of flies has latched onto you, making it harder to land a meaningful blow!","",nil,{"-25% Melee Critical Chance","-25% Ranged Critical Chance","-25% Tactical Critical Chance"}}
EpicEffect[41]={"Clutch of Flies I","A distinct buzzing sound can be heard coming from an ill-attached sack on the monster's hip. A wrong move on its part and it could easily open up.","Cleanse Corruption"}
EpicEffect[42]={"Sauron's Touch I","Monsters are blessed by Sauron with increased damage and toughness. Corruption.","Cleanse Corruption",nil,{}}
EpicEffect[43]={"Sauron's Touch I","The Touch of Sauron exudes from this creature, enhancing nearby allies","",nil,{"+30% Melee Damage","+30% Ranged Damage","+30% Tactical Damage","-15% Incoming Melee Damage","-15% Incoming Ranged Damage","-15% Incoming Tactical Damage"}}
EpicEffect[44]={"Debilitating Miasma","The miasma lessens the effectiveness of your attacks.","Move away",nil,{"-10% Melee Offence","-10% Ranged Offence","-10% Tactical Offence"}}
EpicEffect[45]={"Hampering Miasma","The miasma surrounding this foe is hampering, and fighting in it will make your attacks less effective.","",nil,{}}
EpicEffect[46]={"Hampering Miasma","The miasma lessens the effectiveness of your attacks.","Move away",nil,{"-10% Melee Offence","-10% Ranged Offence","-10% Tactical Offence"}}
EpicEffect[47]={"Atrophy","You feel poison in your veins, sapping your strength.","Cure Poison",60,{"x0.75 Outgoing Damage","x0.75 Tactical Damage"}}
EpicEffect[48]={"True Face of Fear","An unrelenting fear that weakens the resolve.","Clear Fear",10,{"Reduces outgoing healing by 100%","Applied on removal: Subtracts 15% of maximum Morale"}}
EpicEffect[49]={"Festering Wound","Vile pustules are forming upon your wound. Cleanse the injury before they burst.","Cure Wound",10,{}}
EpicEffect[51]={"Sauron's Ire","Flames leap toward and surround you!","Cure Wound",9,{"Every 3 seconds: Subtracts 20% of maximum Morale"}}
EpicEffect[52]={"Fear of Death","Fearing death, this creature is dangerously enraged.","",nil,{"x2 Outgoing Damage"}}
EpicEffect[53]={"Sauron's Word","The icy, black speech of Sauron grips your heart. You cannot help buy flee!","Clear Fear",6,{}}
EpicEffect[54]={"Sauron's Wrath","These creatures have been inspired by their leader to do more damage!","",30,{"+200% Melee Damage","+200% Ranged Damage","+200% Tactical Damage"}}

EpicVariant={} -- variant 1-6 cycles daily
EpicVariant[1]={} -- tier 1-12 (9 is blank due to EpicMalice) - note, effect (third value) can be a single number or a table of numbers if multiple effects apply such as with Blood Rage
EpicVariant[1][1]={"Hampering Miasma","These monsters have a diseased aura about them. This will lessen your damage while around them.",{45,46}}
EpicVariant[1][2]={"Atrophy","On death, monsters spray you with a debilitating poison that limits your damage! Curable",47}
EpicVariant[1][3]={"Sauron's Touch I","Monsters are blessed by Sauron with increased damage and toughness. Corruption",{42,43}}
EpicVariant[1][4]={"Clutch of Flies I","On player crit, monsters release a clutch of flies which lowers your critical chance.",{41,39}}
EpicVariant[1][5]={"Sauron's Grasp","After a brief induction, create a damaging whirlwind that targets the player."}
EpicVariant[1][6]={"Miasma II","These monsters have a stronger diseased aura about them. This will lessen your damage while around them.",{4,44}}
EpicVariant[1][7]={"Face of Fear","Reduces your outgoing healing and applies damage on removal",48}
EpicVariant[1][8]={"Glass Cannon","Monsters take and deal double damage",3}
EpicVariant[1][9]={"Epic Fervour","Every enemy you defeat makes you stronger."}
EpicVariant[1][10]={"Twisted Armour","Enemies summon a cursed hotspot that protects enemies more and more over time. Move them away from it!"}
EpicVariant[1][11]={"Clutch of Flies II","On player crit, monsters release a clutch of flies which lowers your critical chance.",{1,40}}
EpicVariant[1][12]={"Vengeance","On monster death, their spirit comes back to get their vengeance!"}

EpicVariant[2]={} -- tier 5-12 (9 is blank due to EpicMalice)
EpicVariant[2][1]={"Fire Storm I","Monsters summon large inferno-storms",13}
EpicVariant[2][2]={"Festering Wound","Monster attacks are poisoned and give festering wounds! Cleanse them before it's too late.",49}
EpicVariant[2][3]={"For the Warleader","On defeat, enemies are inspired to fight harder. Increases nearby enemy mitigation and damage.",2}
EpicVariant[2][4]={"Sauron's Defence I","A corruption shields these monsters and reflects back a portion of your damage.",5}
EpicVariant[2][5]={"Sauron's Ire","After a brief induction, releases a powerful flame attack",51}
EpicVariant[2][6]={"Fire Storm II","Monsters summon large inferno-storms",14}
EpicVariant[2][7]={"Creeping Doom","A monster attack that will give you doubts about your ability to carry on. Cleanse it, before it incapacitates you!",8}
EpicVariant[2][8]={"Sauron's Shroud","These monsters are shrouded in gloom, making them tougher to see. Also increases their perception range.",7}
EpicVariant[2][9]={"Epic Orc Tunnels","Orcs have been digging under your feet! Every 45 seconds an Orc tunnel will appear. Destroy the tunnel before Orcs emerge."}
EpicVariant[2][10]={"Twisted Growth","Enemies summon a cursed hotspot that builds monster damage over time. Move them away from it!"}
EpicVariant[2][11]={"Sauron's Defence II","A corruption shields these monsters and reflects back a portion of your damage.",6}
EpicVariant[2][12]={"Pestilent Discharge","On monster death, an explosive fungus grows from the monster's body, and you are slowed.",32}

EpicVariant[3]={} -- tier 5-12 (9 is blank due to EpicMalice)
EpicVariant[3][1]={"Damaging Clouds I", "Monsters summon damaging acid clouds",9}
EpicVariant[3][2]={"Explosive Devastation I","Monsters burst into flames on death. If you are standing near the monster, you are also burned in the conflagration.",11}
EpicVariant[3][3]={"Fear of Death I","At 40% health, monsters deal double damage.",52}
EpicVariant[3][4]={"Blood Rage I","Enemies take and deal 25% less damage until at 40% health. Then, monsters deal and take 25% more damage.",{15,16}}
EpicVariant[3][5]={"Sauron's Army","After a brief induction, the Enemy calls upon their allies to join the fight against you."}
EpicVariant[3][6]={"Damaging Clouds II","Monsters summon damaging acid clouds",10}
EpicVariant[3][7]={"Explosive Devastation II","Monsters burst into flames on death. If you are standing near the monster, you are also burned in the conflagration.",12}
EpicVariant[3][8]={"Deadly at Range","Monsters deal increased ranged damage.",36}
EpicVariant[3][9]={"Epic Tempest","Large clouds form that float near the ground and spawn various effects when you and monsters stand in them."}
EpicVariant[3][10]={"Twisted Flesh","Enemies summon a cursed hotspot that builds monster healing over time. Move them away from it!"}
EpicVariant[3][11]={"Blood Rage II","Enemies take and deal 25% less damage until at 40% health. Then, monsters deal and take 25% more damage.",{17,18}}
EpicVariant[3][12]={"Vengeance","On monster death, their spirit comes back to get their vengeance!"}

EpicVariant[4]={} -- tier 5-12 (9 is blank due to EpicMalice)
EpicVariant[4][1]={"Poison Puddles I","Monsters summon poisonous acid puddles.",22}
EpicVariant[4][2]={"Diseased Foes","On death, monsters spread vile disease to you, lowering your max health by 30%",24}
EpicVariant[4][3]={"Explosive Regeneration","On monster death, this malice heals nearby monsters."}
EpicVariant[4][4]={"High on Life I","Enemies start out doing double damage. Once reduced below 85% health, this malice abandons them.",19}
EpicVariant[4][5]={"Sauron's Word","After a brief induction, a strong fear consumes you, causing you to lose control of your limbs.",53}
EpicVariant[4][6]={"Poison Puddles II","Monsters summon poisonous acid puddles.",23}
EpicVariant[4][7]={"Virulent Discharge","Monsters discharge a virulent substance that will knock you down if not cleansed."}
EpicVariant[4][8]={"Sauron's Lash","Monsters are fast. Really fast.",21}
EpicVariant[4][9]={"Epic Orc Tunnels","Orcs have been digging under your feet! Every 45 seconds an Orc tunnel will appear. Destroy the tunnel before Orcs emerge."}
EpicVariant[4][10]={"Twisted Growth","Enemies summon a cursed hotspot that builds monster damage over time. Move them away from it!"}
EpicVariant[4][11]={"High on Life II","Enemies start out doing double damage. Once reduced below 85% health, this malice abandons them.",20}
EpicVariant[4][12]={"Hydra","On defeat, monsters explode into weaker monsters."}

EpicVariant[5]={} -- tier 5-12 (9 is blank due to EpicMalice)
EpicVariant[5][1]={"Damaging Clouds I", "Monsters summon damaging acid clouds",9}
EpicVariant[5][2]={"Stab at Thee","On monster death, with a dying gasp the monster reaches out and wounds you! Cleanse it quickly!",25}
EpicVariant[5][3]={"Health Poultices","While this enemy is above 85% health, they will heal themselves continuously.",26}
EpicVariant[5][4]={"Thick Hide","Incoming damage on monsters is reduced by half until they are struck with a critical blow.",27}
EpicVariant[5][5]={"Sauron's Blessing","After a brief induction, heal all nearby allies to full health."}
EpicVariant[5][6]={"Encroaching Shadow","Monsters summon the shadows to cover them and mitigate damage",28}
EpicVariant[5][7]={"Lingering Fear","A monster attack that will greatly reduce your ability to heal yourself and others. Cleanse yourself!",29}
EpicVariant[5][8]={"Melee Mastery","Monsters deal increased melee damage.",30}
EpicVariant[5][9]={"Epic Fervour","Every enemy you defeat makes you stronger."}
EpicVariant[5][10]={"Twisted Armour","Enemies summon a cursed hotspot that protects enemies more and more over time. Move them away from it!"}
EpicVariant[5][11]={"Sauron's Eye III","These monsters have a dreadful aura about them. Adds 3 to the current level of Dread when in range.",31}
EpicVariant[5][12]={"Pestilent Discharge","On monster death, an explosive fungus grows from the monster's body, and you are slowed.",32}

EpicVariant[6]={} -- tier 5-12 (9 is blank due to EpicMalice)
EpicVariant[6][1]={"Slime Puddles I","Monsters summon slime puddles that increase your chance to miss.",33}
EpicVariant[6][2]={"Instilled Panic","On monster death, you have reduced critical chance and defence.",34}
EpicVariant[6][3]={"Glory In Pain","This malice heals monsters you strike. It grows stronger the more times the monsters are attacked.",35}
EpicVariant[6][4]={"Physical Adaptation I","After your first attack, monsters gain protection based on that damage type. Corruption."}
EpicVariant[6][5]={"Sauron's Wrath","After a brief induction, buffs all nearby monsters to do extra damage.",54}
EpicVariant[6][6]={"Slime Puddles II","Monsters summon debilitating slime puddles that have a chance to incapacitate you."}
EpicVariant[6][7]={"Infested!","There's a shooting pain in your abdomen, and also a squirming sensation... almost as if there were... something moving.",38}
EpicVariant[6][8]={"Tactical Mastery","Expert training has made this creature a dangerous foe to face in tactical combat.",37}
EpicVariant[6][9]={"Epic Tempest","Large clouds form that float near the ground and spawn various effects when you and monsters stand in them."}
EpicVariant[6][10]={"Twisted Flesh","Enemies summon a cursed hotspot that builds monster healing over time. Move them away from it!"}
EpicVariant[6][11]={"Physical Adaptation II","After your first attack, monsters gain protection based on that damage type."}
EpicVariant[6][12]={"Hydra","On defeat, monsters explode into weaker monsters."}

--*** 2=FR French version
--*** 3=DE German Version
